program Graph_33c;
{
    "-" 
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

procedure Test(aRetry, aNodes: integer);

//     
const CArrSize = 50; // 50   0,5% ( 25 %)

var Gr : TGraph;          //  
    Res : TBuffer;        //  -  
    Cost, CostF: integer; // 

    TF, TH, TQ : integer; //  
    MaxH, MaxQ : extended;  //  
    SumH, SumQ : extended;  //  
    Start : TDateTime;    //   

    Cnt : integer;      //  
    Delta : integer;    //  
    pc :  extended;     //   %
    Index: integer;     //   

    //      (25%   0,5%)
    ArrH, ArrQ : array [0..CArrSize] of integer;

   //  
  procedure Expo(const aFileName: String);
  const CLine = '---------------------------------------------------------';
  var i : integer;
      exist: boolean;
  begin
    exist:= true;
    if aFileName <> '' then begin
      Assign(Output, aFileName);
      exist:= FileExists(aFileName);
      if exist then Append(Output) else Rewrite(Output)
    end;
    if not exist then Writeln(aFileName);
    Writeln(CLine);
    Writeln('Retry=', aRetry:4,  '  Nodes=', aNodes:4);
    Writeln(CLine);
    Writeln('                  F         H         Q');
    //  , 
    Writeln('Time (ms)= ', TF/aRetry:10:1, TH/aRetry:10:1, TQ/aRetry:10:1);
    //  
    Writeln('Max  (%%)= ', 0.0:10:1, (MaxH-100):10:1, (MaxQ-100):10:1);
    //   
    Writeln('Aver (%%)= ', 0.0:10:1,
            Sqrt(SumH/aRetry):10:1,
            Sqrt(SumQ/aRetry):10:1);
    Writeln(CLine);
    //  
    if Abs(aNodes) < 15 then begin
      for i:= 0 to CArrSize-1 do Writeln(i:2, #9, 100*ArrH[i]/aRetry:6:1);
      Writeln(CLine);
    end;
    if not Gr.mDirect then begin
      for i:= 0 to CArrSize-1 do Writeln(i:2, #9, 100*ArrQ[i]/aRetry:6:1);
      Writeln(CLine);
    end;
    if aFileName <> '' then begin
      Close(Output);  Assign(Output, '');    Rewrite(Output);
    end;
  end;

begin  { Test }

    FillChar(ArrH, SizeOf(ArrH), 0);
    FillChar(ArrQ, SizeOf(ArrH), 0);

    //  
    TF:=0; TH:=0; TQ:=0;
    //  
    MaxH:= 0; MaxQ:= 0;
    //  
    SumH:= 0; SumQ:= 0;

    for Cnt:= 1 to aRetry do begin
      Gr:= TGraphChars.GenFull((aNodes>0), 0, 99, Abs(aNodes));
      {-------- Full -------}
      CostF:= 0;
      if Abs(aNodes) < 15 then begin
        Start:= Now;
        Res:= Gr.GenHamilton_Full(CostF);
        Inc(TF, MilliSecondsBetween(Start, Now));
        Res.Free;
      end;
      {-------- Main -------}
      Start:= Now;
      Res:= Gr.GenHamilton(Cost);
      Inc(TH, MilliSecondsBetween(Start, Now));
      Res.Free;
      if CostF=0 then CostF:= Cost; //    
      Delta:= Cost - CostF;         //  
      if Delta=0 then Write('.') else Write('*');
      pc:= 100 * Cost / CostF;      //   pc >= 100 %
      if MaxH < pc then MaxH:= pc;  //  
      SumH:= SumH + (pc-100)*(pc-100);
      //      0,5 %:
      Index:= Round(2*(pc-100));
      if Index < CArrSize then Inc(ArrH[Index]);

      {-------- Quick -------}
      if not Gr.mDirect then begin
        Start:= Now;
        Res:= Gr.GenHamilton_Quick(Cost);
        Inc(TQ, MilliSecondsBetween(Start, Now));
        Res.Free;
        Delta:= Cost - CostF;    //  
        //    (Cost  CostF)  
        if Delta<0 then begin
          Delta:= 0;
          CostF:= Cost;
        end;
        if Delta=0 then Write('.') else Write('@');
        pc:= 100 * Cost / CostF;      //   pc >= 100 %
        if MaxQ < pc then MaxQ:= pc;  //  
        SumQ:= SumQ + (pc-100)*(pc-100);
        //      0,5 %:
        Index:= Round(2*(pc-100));
        if Index < CArrSize then Inc(ArrQ[Index]);
      end;

      Gr.Free;
    end; // for
    Writeln(#7);
    //  
    Expo('');
//    Expo('Out_19c_2015-08-19.txt');
end;

{-------------------------------------------------------}

var Nodes: integer;
    Retry : integer;

begin
  try
    Write('Retry= '); Readln(Retry);
    if Retry = 0 then Exit;

    repeat
      Write('Nodes= '); Readln(Nodes);
      if Abs(Nodes) < 4 then Break;
      Test(Retry, Nodes);
    until false;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

