unit Dissect;
//************************************************************************
//                                       *
// :                                                              *
// GenAllDissections --                   *
// GenDissectRand --                *
// GenSubsRand --                 *
// GenSubsFromText --             *
//************************************************************************

interface

uses Root, Items, SetList;

//     aSet

function GenAllDissections(aSet: TSet): TSet;

//    aCnt  
//   aSet.
//       ,
//   

function GenDissectRand(
                     aSet: TSet;  {   }
                     aCnt,  {    }
                     aMin,  {   , %}
                     aMax   {   , %}
                     : integer): TSet;

//    aCnt  
//   aSet.
//      (%)  ,
//   
//       :
// -     aSet
// --    
//        
//     .

function GenSubsRand(aSet: TSet;  {   }
                     aCnt,  {    }
                     aMin,  {   , %}
                     aMax   {   , %}
                     : integer): TBuffer;

//    
//   TBuffer   aSet
//    'a'..'z'

function GenSubsFromText(const aName: String;  //  
                         var aSet: TSet;       // -
                         aCnt: integer         //  
                         ): TBuffer;

//////////////////////////////////////////////////////////////////////////
implementation
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//     ( ,  43 )
//////////////////////////////////////////////////////////////////////////

function GenAllDissections(aSet: TSet): TSet;
var Que    : TBuffer;  // -
    SSGet  : TSet;       //   
    SSPut : TSet;        //   
    //------------------------------------------
    //    
    //    SSGet

    procedure LocalHandle(aItem: TItem);
    var k: integer;
        S: TSet;     //     
    begin
      //      SSGet,
      //   - S:
      for k:= 1 to SSGet.GetCount do begin
          SSPut:= SSGet.Copy as TSet;   //  .  
          S:= SSPut.GetItem(k) as TSet; //    
          SSPut.Delete(S);   //     
          S.Insert(aItem);   //     
          SSPut.Insert(S);   //     
          Que.Put(SSPut);    //      
      end;
      //     SSGet
      SSPut:= SSGet.Copy as TSet;  //  .  
      S:= CreateSet;      //  
      S.Insert(aItem);    //    aItem
      SSPut.Insert(S);    //    
      Que.Put(SSPut);     //      
    end;
    //------------------------------------------

var   i, j  : integer;  // 
      Item: TItem;      //    

begin
  Que:= TBuffer.Create; //    
  SSPut:= CreateSet;      //   
  Que.Put(SSPut);         //   
  //      :
  for i:= 1 to aSet.GetCount do begin
    Item:= aSet.GetItem(i);
    //   :
    for j:=1 to Que.GetCount do begin
      SSGet:= Que.Get as TSet;  //     
      LocalHandle(Item);        //     
      SSGet.ClrAndDestroy;      //   
      SSGet.Free;               //  
    end;
  end;
  Result:= CreateSet; //   
  //     -
  while Que.GetCount>0 do Result.Insert(Que.Get);
  Que.Free;  //  
end;

//////////////////////////////////////////////////////////////////////////
//       aSet
//  : aSet !
//////////////////////////////////////////////////////////////////////////

function GenRandSet(aMin, aMax: integer; aSet: TSet): TSet;
var n, k, j: integer;
    t: TItem;
    S: TSet;
begin
  Result:= CreateSet;                //  -
  repeat
    n:= aMin + Random(aMax-aMin);    //   
    S:= CreateSet;                   //  
    for j:= 1 to n do begin          //      -
      k:= 1 + Random(aSet.GetCount); //     
      t:= aSet.GetItem(k);           //    
      S.Insert(t);                   //   
      aSet.Delete(t);                //    
      if aSet.GetCount=0 then Break; //   ,  
    end;
    if S.GetCount>0          //    ,
      then Result.Insert(S)  //    
      else S.Free;           //   
  until aSet.GetCount=0;     //     
end;

//////////////////////////////////////////////////////////////////////////
//    aCnt  
//   aSet.
//      (%)  ,
//   
//////////////////////////////////////////////////////////////////////////

function GenDissectRand(
                     aSet: TSet;  {   }
                     aCnt,  {    }
                     aMin,  {   , %}
                     aMax   {   , %}
                     : integer): TSet;
var
  nMin, nMax: Integer;
  Copy: TSet;   //     aSet
  SS: TSet;     //   
  i: Integer;

begin
  //    

  nMin:= (aSet.GetCount * aMin) div 100;   // aMin %
  if nMin<1 then nMin:=1;
  if nMin>=aSet.GetCount then nMin:=aSet.GetCount-1;

  nMax:= (aSet.GetCount * aMax) div 100;   // aMax %
  if nMax<nMin then nMax:=nMin;
  if nMax>aSet.GetCount then nMax:=aSet.GetCount;

  Result:= CreateSet;
  for i:= 1 to aCnt do begin
    Copy:= aSet.Copy as TSet;
    repeat
      SS:= GenRandSet(nMin, nMax, Copy);
      Result.Insert(SS);
    until Copy.GetCount=0;
    Copy.Free;
  end;
end;

//////////////////////////////////////////////////////////////////////////
//    aCnt  
//   aSet.
//      (%)  ,
//   
//       
//     .
//////////////////////////////////////////////////////////////////////////

function GenSubsRand(aSet: TSet;  {   }
                     aCnt,  {    }
                     aMin,  {   , %}
                     aMax   {   , %}
                     : integer): TBuffer;
var
  nMin, nMax: Integer;
  Copy: TSet;  //     aSet
  SS: TSet;    //  
  S : TSet;    //    

begin
  //    

  nMin:= (aSet.GetCount * aMin) div 100;   // aMin %
  if nMin<1 then nMin:=1;
  if nMin>=aSet.GetCount then nMin:=aSet.GetCount-1;

  nMax:= (aSet.GetCount * aMax) div 100;   // aMax %
  if nMax<nMin then nMax:=nMin;
  if nMax>aSet.GetCount then nMax:=aSet.GetCount;

  Result:= TBuffer.Create;  //   

  //     

  while aCnt>0 do begin
    Copy:= aSet.Copy as TSet;   //    
    repeat
      SS:= GenRandSet(nMin, nMax, Copy);  //   
      //    :
      S:= SS.GetFirst as TSet;   //    
      while Assigned(S) and (aCnt>0) do begin
        if Random(3)<>0 then begin
          //   ""
          //   2/3   
          Result.Put(S.Copy);
          Dec(aCnt);
        end;
        S:= SS.GetNext as TSet;  //    
      end;
      SS.ClrAndDestroy;  //  
      SS.Free;           //   
    until (aCnt=0) or (Copy.GetCount=0);
    Copy.Free;   //    
  end;
end;

//////////////////////////////////////////////////////////////////////////
//    
//   TBuffer   aSet
//    'a'..'z'
//////////////////////////////////////////////////////////////////////////

function GenSubsFromText(const aName: String;  //  
                         var aSet: TSet;       // -
                         aCnt: integer         //  
                         ): TBuffer;

type TChrSet = set of char;

    // - - - - - - - - - - - - - - - - - - - - - - - - - -
    //  - 
    //    

    function MakeFromSet(const aSet: TChrSet): TSet;
    var c: char;
        t: TItemChar;
    begin
      Result:= CreateSet;
      for c in aSet do begin
        t:= TItemChar.Create(c);
        Result.Insert(t)
      end;
    end;
    // - - - - - - - - - - - - - - - - - - - - - - - - - -

var F: Text;           //  
    S: string;         //  
    c: char;           //  
    i: integer;        // 
    set1 : TChrSet;    //   
    set2 : TChrSet;    //   
    subset: TSet;      //  

begin  { GenSubsFromText }

  Result:= TBuffer.Create;
  set1:= [];
  set2:= [];
  Assign(F, aName); Reset(F);
  while not Eof(F) do begin
    if Result.GetCount >= aCnt then break;
    Readln(F, S);
    for i:= 1 to Length(S) do begin
      //    :
      if Result.GetCount >= aCnt then break;
      c:= Char(Ord(S[i]) or $20);       // low case ( 'a'..'z')
      if c in ['a'..'z'] then begin
        set1:= set1 + [c];              //  
        if c in set2 then begin         //    
           subset:= MakeFromSet(set2);  //  
           Result.Put(subset);          //    
           set2:= [c];                  //   
        end else begin                  //    
           set2:= set2 + [c];           //   
        end;
      end;
    end;
  end;
  Close(F);
  subset:= MakeFromSet(set2);  //  
  Result.Put(subset);          //   
  aSet:= MakeFromSet(set1);    //   
end;

//////////////////////////////////////////////////////////////////////////

end.
